package com.cs427.swordfish.banking;

/*
 * Derived class of Account that doesn't update its rate since it's a checking account.
 */
public class CheckingAccount extends Account {

	// Serializable ID
	private static final long serialVersionUID = 1L;

	/*
	 * Constructor
	 * 
	 * @param p Pin for this account
	 */
	public CheckingAccount(String p) {
		this(0, p);
	}

	/*
	 * Constructor
	 * 
	 * @param startingBalance Starting Balance for this account
	 * 
	 * @param p Pin for this account
	 */
	public CheckingAccount(Integer startingBalance, String p) {
		super(startingBalance, p);
	}

	/*
	 * @see com.cs427.swordfish.banking.Account#update()
	 */
	public void update() {
		// checking doesn't have interest
	}
}
