package com.cs427.swordfish.banking;

/*
 * Derived class from Account that updates balance based on account rate.
 */
public class SavingsAccount extends Account {

	// Serializable ID
	private static final long serialVersionUID = 1L;

	// Interest rate
	private double rate = 0.0;

	/*
	 * Constructor
	 * 
	 * @param p Pin for this account
	 * 
	 * @param rate Rate for this account
	 */
	public SavingsAccount(String p, Double rate) {
		this(0, p, rate);
	}

	/*
	 * Constructor
	 * 
	 * @param startingBalance Starting Balance for this account
	 * 
	 * @param p Pin for this account
	 * 
	 * @param r Rate for this account
	 */
	public SavingsAccount(Integer startingBalance, String p, Double r) {
		super(startingBalance, p);
		rate = r;
	}

	/*
	 * @see com.cs427.swordfish.banking.Account#update()
	 */
	public void update() {
		cents = ((int) (cents * (1 + rate)));
	}

}
