package edu.illinois.cs.cs427.clownfish.actorBanking;

public class LogEntry {
	private String date;
	private String amount;
	private String type;
	private String accountTwo;
	
	/**
	 * Creates a log entry for an owning account
	 * @param date the time and date
	 * @param amt the amount of the transaction
	 * @param type the transaction type
	 * @param accountTwo the other account involved if type is transfer
	 * @throws RemoteCodeException
	 */
	public LogEntry(String date, String amount, String type, String accountTwo) {
		this.date = date;
		this.amount = amount;
		this.type = type;
		this.accountTwo = accountTwo;
	}
	
	/**
	 * Gets the date of the log entry
	 * 
	 * @return String the date
	 */
	public String getDate() {
		return date;
	}
	
	/**
	 * Gets the amount of the log entry
	 * 
	 * @return Integer the balance
	 */
	public String getAmount() {
		return amount;
	}
	
	/**
	 * Gets the type of the log entry
	 * 
	 * @return String the type of the transaction
	 */
	public String getType() {
		return type;
	}
	
	/**
	 * Gets the second account of the log entry
	 * 
	 * @return Integer the second account number
	 */
	public String getAcct() {
		return accountTwo;
	}
}
