package edu.illinois.cs.cs427.clownfish.actorBanking;

import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.RemoteCodeException;
import osl.manager.annotations.message;

public class TestContext extends Actor {
	private ActorName bank;
	private ActorName atm;
	private ActorName atm2;
	private Integer account1Id;
	private Integer account2Id;
	private Integer pin1;
	private Integer pin2;
	public static final int initialBalance1 = 100;
	public static final int initialBalance2 = 200;
	
	/**
	 * A constructor for the TestContext class
	 * Performs no actions
	 */
	public TestContext() {}
	
	
	/**
	 * Initializes the standard elements of a TestContext
	 * @return an ActorName representing the TestContext 
	 * @throws RemoteCodeException
	 */
	@message
	public ActorName getNewTestContext() throws RemoteCodeException
	{
		init();
		return self();
	}
	
	@message
	private void init() throws RemoteCodeException
	{
		bank = create(ActorBank.class);
		call(bank, "initialize");
		atm = create(ActorATM.class, bank);
		atm2 = create(ActorATM.class, bank);
		pin1 = 1111;
		pin2 = 2222;
		account1Id = (Integer) call(atm, "openAccount", TestContext.initialBalance1, pin1);
		account2Id = (Integer) call(atm, "openAccount", TestContext.initialBalance2, pin2);
	}
	
	/**
	 * 
	 * @return the bank stored by the TestContext
	 */
	@message
	public ActorName getBank()
	{
		return bank;
	}
	
	/**
	 * 
	 * @return the ATM stored by the TestContext
	 */
	@message
	public ActorName getATM()
	{
		return atm;
	}
	
	/**
	 * 
	 * @return the ATM stored by the TestContext
	 */
	@message
	public ActorName getSecondATM()
	{
		return atm2;
	}
	
	/**
	 * 
	 * @return the first account number stored by the TestContext
	 */
	@message
	public Integer getFirstAccount()
	{
		return account1Id;
	}
	
	/**
	 * 
	 * @return the first pin stored by the TestContext
	 */
	@message
	public Integer getFirstPin()
	{
		return pin1;
	}
	
	/**
	 * 
	 * @return the second account stored by the TestContext
	 */
	@message
	public Integer getSecondAccount()
	{
		return account2Id;
	}
	
	
	/**
	 * 
	 * @return the second pin stored by the TestContext
	 */
	@message
	public Integer getSecondPin()
	{
		return pin2;
	}
}
