/*
 * Authors:
 * 
 * Jeffrey Dennhardt
 * Kurt Hendle
 * Yuzuko Nakamura
 * Jurand Nogiec
 * 
 * Written Fall 2009
 */

package edu.illinois.cs427.Banking;


public class Account {


	private Double balance;
	private String accountNumber;
	

	public Account() {
		this.balance = 0.0;
	}
	
	/**
	 * All accounts start with a zero balance
	 * @param accountNumber
	 */
	public Account(String accountNumber) {
		this.accountNumber = accountNumber;
		this.balance = 0.0;
	}
	
	/**
	 * balance getter method
	 * @return balance
	 */
	public Double getBalance() {
		return balance;
	}
	
	/**
	 * number getter method
	 * @return account number
	 */
	public String getAccountNumber() {
		return accountNumber;
	}
	

	/**
	 * Deposit update method
	 */
	public void deposit(Double amount) {
		this.balance += amount;
	}
	
	/**
	 * Withdraw if there is enough balance.
	 * @param amount
	 */
	public void withdraw(Double amount) {
		if(this.balance>=amount)
			this.balance -= amount;
	}
}
