package paper.philosophers;

import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.RemoteCodeException;
import osl.manager.annotations.message;

public class Driver extends Actor {

  public static int N = 30000; // can specify 1 or higher

  @message
  public void explore() throws RemoteCodeException {
    ActorName[] forks = new ActorName[N];

    for (int i = 0; i < N; i++)
      forks[i] = create(Fork.class);

    ActorName[] philosophers = new ActorName[N];
    for (int i = 0; i < N; i++) {
      philosophers[i] = create(Philosopher.class, forks[i],
          forks[(i + 1) % N]);
      send(philosophers[i], "eat");
    }

  }

}
