package paper.philosophers;

import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.annotations.message;
import osl.util.constraints.Disable;

public class Fork extends Actor {

  private boolean held = false;

  
  @message
  public void pickup(ActorName sender) {
    //System.out.println(sender + " is picking up " + this);
    send(sender, "givefork");
    held = true;
  }

  @Disable(messageName = "pickup")
  public Boolean pickupDisabled(ActorName sender) {
    return held;
    //disables return true when the action is not valid
  }

  @message
  public void putdown(ActorName sender) {
    //System.out.println(sender + " is putting down " + this);
    held = false;
    // do nothing
  }
}
