package paper.philosophers;

import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.annotations.message;

public class Philosopher extends Actor  {
  public static int EATING_THRESHOLD = 1;
  private int eated = 0;
  
  private final ActorName leftFork;
  private final ActorName rightFork;
  
  private int holdedForks = 0;
  
  public Philosopher(ActorName left, ActorName right) {
    this.leftFork = left;
    this.rightFork = right;
  }

  @message
  public void eat() {
    if(eated < EATING_THRESHOLD) {
      eated++;
      send(leftFork,  "pickup", self());
      send(rightFork, "pickup", self());
    }
  }
  
  @message
  public void givefork() {
    assert(holdedForks < 2);
    holdedForks++;
    
    if(holdedForks < 2)
      return;
    
    //System.out.println(this+" can finally eat!");
    send(leftFork,  "putdown", self());
    send(rightFork, "putdown", self());
    holdedForks = 0;
  }
}
