package paper.pi;

import java.util.List;

import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.annotations.message;

public class Master extends Actor {

  private final ActorName[] workers;

  private int counter = 0;
  private double result = 0.0;
  
  public Master(Object workers) {
    this.workers = (ActorName[])workers;
  }
  
  @message
  public void boot() {
    int n = 30000; //1000
    
    for(ActorName w: workers) {
      send(w,"intervals", self(), n);
    }
  }
  
  @message
  public void sum(Double p) {
    counter++;
    result += p;
    
    if(counter == workers.length) {
      for(ActorName w: workers) {
        send(w,"stop");
      }
      System.out.println("result = " + result);
      destroy("stop"); 
    }
  }
}
