package paper.pi;

import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.annotations.message;

public class Worker extends Actor {
  
  private final int id;
  private final int nbWorkers;
  
  public Worker(Integer id, Integer nb) {
    this.id = id;
    this.nbWorkers = nb;
  }
  
  @message
  public void intervals(ActorName sender, Integer n) {
    double h = 1.0 / n;
    
    double sum = 0;
    for(int i = id; i <=n; i += nbWorkers) {
      double x = h * ( i - 0.5);
      sum += (4.0 / (1.0 + x*x));
    }
    
    send(sender, "sum", h * sum);
  }

  
  @message
  public void stop() {
    destroy("stop");
  }
}
