package rainbow_fish.project;

import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.RemoteCodeException;
import osl.manager.annotations.message;

public class __TestBankActor extends Actor {
	/**
	 * 
	 */
	private static final long serialVersionUID = 8224635902702957248L;

	/**
	 * Call all the tests inside this class
	 * @throws RemoteCodeException
	 */
	@message
	public void testAll() throws RemoteCodeException {
		testOpenAndCloseAccount();
	}

	/**
	 * Test open and close method inside BankActor.
	 * Also check if account still exist after closing.
	 * @throws RemoteCodeException
	 */
	@message
	public void testOpenAndCloseAccount() throws RemoteCodeException {
		ActorName bank = create(BankActor.class);
		String id = (String) call(bank, "openAccount");
		Response afterOpen = (Response) call(bank, "accountExists", id);
		if (afterOpen instanceof FailureResponse)
			System.out.println(((FailureResponse) afterOpen).getMessage());

		call(bank, "closeAccount", id);
		Response afterClose = (Response) call(bank, "accountExists", id);
		if (afterClose instanceof SuccessResponse)
			System.out.println("Account still exist after close");
	}
}
